let loadingMessageDiv = document.getElementById("loadingMessageDiv");
let lobbySettingsDiv = document.getElementById("lobbySettingsDiv");
let roundsSelect = document.getElementById("roundsSelect");
let playerList = document.getElementById("playerList");
let startButton = document.getElementById("startButton");
let gameForm = document.getElementById("gameForm");

let webSocket = null;

function init()
{
	webSocket = new WebSocket("ws://" + window.location.host + "/ws/lobby/" + lobbyId);
	webSocket.onmessage = function(e) { onReceiveMessage(e.data); }
	webSocket.onopen = function() { sendMessage("joinLobby", nickname); };
}

function sendMessage(type, data)
{
	webSocket.send(JSON.stringify({ type: type, data: data }));
}

function onReceiveMessage(messageText)
{
	let message = JSON.parse(messageText);

	switch(message.type)
	{
		case "setLobbyInfo":
			loadingMessageDiv.style.display = "none";
			lobbySettingsDiv.style.display = "";

			roundsSelect.value = message.data.numberOfRounds;

			playerList.innerHTML = "";
			for(player of message.data.players)
			{
				let playerItem = document.createElement("li");
				playerItem.innerText = (player == message.data.leader ? player + " ★" : player);
				playerList.appendChild(playerItem);
			}

			let leader = message.data.leader == nickname;
			roundsSelect.disabled = !leader;
			startButton.disabled = !(leader && message.data.players.length > 1);
			break;
		case "startGame":
			gameForm.submit();
			break;
		default:
			console.log("Unknown message type: " + message.type);
			break;
	}
}

roundsSelect.onchange = function(e) {
	sendMessage("setNumberOfRounds", roundsSelect.value);
}

startButton.onclick = function(e) {
	sendMessage("startGame", null);
}

init();
